{#if imageOnly}
  <img src={imageProxy}
       {width}
       {height}
       class="image-preview image-standalone-preview" />
{:else}
<div class="message-embed"
     class:no-grow="!width || !height"
     style={`width: ${wholeWidth}px;`}>
  <div class="embed-color" style={`background-color: ${color ? "#" + color.toString(16).padStart(6, "0") : "#111"};`} />
  <div class="embed-content">
    {#if title}
    <h2 class="title">
      <a class="title-link" href={link}>
        <MarkdownParser content={title} />
      </a>
    </h2>
    {/if}
    {#if description}
    <p class="description">
      <MarkdownParser content={description} />
    </p>
    {/if}
    {#if player && image}
    <div class="player"
         on:mouseenter="set({lighten: true})"
         on:mouseleave="set({lighten: false})"
         on:click="set({playing: true})"
         style={`width: ${width}px; height: ${height}px;`}
         class:playing="playing">
      {#if playing}
      <iframe src={autoPlayer}
              {height}
              {width}
              allow="autoplay; fullscreen"
              allowFullscren
              class="player-frame" />
      {:else}
      <img src={imageProxy}
           {height}
           {width}
           class="player-image image-preview" />
      <div class="play-btn">
        <PlayIcon {lighten} />
      </div>
      {/if}
    </div>
    {:elseif image}
    <img src={imageProxy}
         {width}
         {height}
         class="image-preview image-standalone-preview" />
    {/if}
  </div>
</div>
{/if}

<style>
  .message-embed {
    margin: 0.25em 0;
    background: #1d1d1d;
    display: flex;
    flex-direction: row;
  }

  .embed-color {
    width: 0.375em;
    height: inherit;
    flex-shrink: 0;
    flex-grow: 0;
    border-radius: 5px 0 0 5px;
  }

  .embed-content {
    flex-grow: 1;
    flex-shrink: 1;
    width: 100%;
    height: 100%;
    height: inherit;
    display: flex;
    flex-direction: column;
    padding: 0.5em 0.5em 0.3em 0.5em;
    border: solid 1px #181818;
    border-left: none;
    border-radius: 0 5px 5px 0;
  }

  .description {
    margin: 0.25em 0 0 0;
    color: #ededed;
    font-size: 0.9em;
  }

  .title {
    margin: 0;
    font-size: 0.9em;
  }

  .title-link {
    display: inline-block;
    text-decoration: none;
    color: #3594fd;
  }

  .title-link:hover {
    text-decoration: underline;
  }

  .image-preview {
    flex-grow: 1;
    flex-shrink: 1;
  }

  .player {
    position: relative;
  }

  .play-btn {
    text-align: center;
    top: 0;
    bottom: 0;
    margin: auto;
    position: absolute;
    height: 3em;
    width: 100%;
  }

  .player-frame, .image-preview {
    border-radius: 5px;
  }

  .player, .image-standalone-preview {
    margin-top: 0.25em;
    margin-bottom: 0.2em;
  }

  .player-image {
    transition: filter 0.2s ease-out;
  }

  .player:not(.playing) {
    cursor: pointer;
  }

  .player:hover .player-image {
    filter: brightness(90%);
  }

  .player-frame {
    border: none;
  }

  .no-grow {
    max-width: 65%;
  }

  @media (max-width: 800px) {
    .no-grow {
      max-width: 80%;
    }
  }

  @media (max-width: 420px) {
    .no-grow {
      max-width: 100%;
    }
  }
</style>

<script>
  import url from "url";
  import env from "../js/constants";

  const imageKeys = [
    "id",
    "link",
    "image",
    "width",
    "height",
    "messageId",
    "guildId",
    "channelId",
    "_n",
    // Unnecessary at that point
    "color"
  ];
  
  export default {
    computed: {
      imageProxy({image}) {
        return env.PROXY_BASE + "?" + encodeURIComponent(image);
      },
      wholeWidth({width, delta}) {
        return width + delta;
      },
      imageOnly({embed}) {
        return embed && !Object.keys(embed).some(key => !imageKeys.includes(key));
      },
      autoPlayer({player}) {
        if (!player) return player;
        const playerObj = url.parse(player);
        const query = new URLSearchParams(playerObj.search || "");
        query.set("autoplay", 1);
        query.set("auto_play", 1);
        playerObj.search = "?" + query.toString();
        return url.format(playerObj);
      },
      widthLimit({$lastWidth}) {
        return ($lastWidth > 420 ? 420 : $lastWidth) - 24 - 24 - 16 - 8 - 8;
      },
      playerRatio({playerHeight, playerWidth, widthLimit}) {
        const widthRatio = widthLimit / playerWidth;
        const heightRatio = 200 / playerHeight;
        return widthRatio < heightRatio ? widthRatio : heightRatio;
      },
      delta({imageOnly}) {
        return imageOnly ? 0 : 6 + 8 + 8;
      },
      width({playerRatio, playerWidth, delta}) {
        return Math.round(playerRatio * playerWidth) - delta;
      },
      height({playerRatio, playerHeight, delta}) {
        return Math.round(playerHeight * playerRatio) - delta;
      }
    },
    components: {
      PlayIcon: "./icons/PlayIcon.svelte",
      MarkdownParser: "./MarkdownParser.svelte"
    }
  };
</script>
